require 'rake'
require 'rubygems'
require 'cucumber'
require 'cucumber/rake/task'
require 'assertthat-bdd'

Cucumber::Rake::Task.new do |t|
  t.cucumber_opts = %w[ --format json -o reports/cucumber.json --format html -o reports/cucumber.html]
end

task :download_features do
 AssertThatBDD::Features.download(
 							  #Optional can be supplied as environment variable bf4d8639aa87ae75de19a184ce5f498c474e7de963d3134c608dcda9b2125ea2
 							  accessKey:'bf4d8639aa87ae75de19a184ce5f498c474e7de963d3134c608dcda9b2125ea2',
							  #Optional can be supplied as environment variable d3024e3fb5ba40fa025dc662e65406e188d699e46847edcb2bd52b7994181926
							  secretKey:'d3024e3fb5ba40fa025dc662e65406e188d699e46847edcb2bd52b7994181926', 
							  #Required Jira project id e.g. 10001
							  projectId: '10000',
							  #Optional - default ./features
							  outputFolder: './features/'
							 ) 
end

task :upload_report do
 AssertThatBDD::Report.upload(
 							  #Optional can be supplied as environment variable bf4d8639aa87ae75de19a184ce5f498c474e7de963d3134c608dcda9b2125ea2
 							  accessKey:'bf4d8639aa87ae75de19a184ce5f498c474e7de963d3134c608dcda9b2125ea2',
							  #Optional can be supplied as environment variable d3024e3fb5ba40fa025dc662e65406e188d699e46847edcb2bd52b7994181926
							  secretKey:'d3024e3fb5ba40fa025dc662e65406e188d699e46847edcb2bd52b7994181926', 
							  #Jira project id e.g. 10001
							  projectId: '10000',
							  #The name of the run - default 'Test run dd MMM yyyy HH:mm:ss'
							  runName: "Dry Tests Run",
    						  #Json report folder - default ./reports
    					      jsonReportFolder: "reports",
    						  #Regex to search for cucumber reports - default .*.json
    						  jsonReportIncludePattern: ".*/cucumber.json"
							 ) 
end

task :cucumber => :download_features

task :default => :cucumber

Rake::Task["cucumber"].enhance do
  Rake::Task[:upload_report].invoke
end